package com.iformall.controller.market;

import com.iformall.annotation.SystemControllerLog;
import com.iformall.controller.base.BaseController;
import io.swagger.annotations.Api;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import com.github.pagehelper.PageInfo;
import com.iformall.common.Result;
import com.iformall.common.ResultData;

import com.iformall.domain.po.WxRefundOrder;
import com.iformall.service.WxRefundOrderService;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;

@RestController
@RequestMapping("/refund")
@Api(description = "微信退款订单接口")
public class WxRefundOrderController extends BaseController {
    private final Logger logger = LoggerFactory.getLogger(this.getClass());

    @Autowired
    private WxRefundOrderService wxRefundOrderService;


    @ApiOperation("分页列表接口")
    @GetMapping("list")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "pageNum", value = "页数", dataType = "int", paramType = "query", required = true),
            @ApiImplicitParam(name = "pageSize", value = "每页条数", dataType = "int", paramType = "query", required = true)})
    @SystemControllerLog(description = "退款-列表")
    public ResultData list(@ModelAttribute WxRefundOrder wxRefundOrder, Integer pageNum, Integer pageSize) {
        logger.debug("[" + getIpAddr() + "] WxRefundOrderController::list");
        if (null == wxRefundOrder) wxRefundOrder = new WxRefundOrder();
        final PageInfo<WxRefundOrder> page = wxRefundOrderService.listAsPage(wxRefundOrder, pageNum, pageSize);
        return new ResultData(page);
    }

    @ApiOperation("新增接口")
    @PostMapping("add")
    @SystemControllerLog(description = "退款-新增")
    public ResultData add(@RequestBody WxRefundOrder wxRefundOrder) {
        logger.debug("[" + getIpAddr() + "] WxRefundOrderController::add");
        //Assert.notNull(wxRefundOrder.getName(), "角色名不能为空");
        //Assert.isTrue(!checkUnique(sysRole.getName(), null), "重复的角色名");
        wxRefundOrderService.saveOrUpdate(wxRefundOrder);
        return new ResultData();
    }

    @ApiOperation("根据id更新接口")
    @PostMapping("update")
    @SystemControllerLog(description = "退款-更新")
    public ResultData update(@RequestBody WxRefundOrder wxRefundOrder) {
        logger.debug("[" + getIpAddr() + "] WxRefundOrderController::update");
        wxRefundOrderService.saveOrUpdate(wxRefundOrder);
        return new ResultData();
    }

    @ApiOperation("根据id删除接口")
    @GetMapping("/del")
    @ApiImplicitParam(name = "id", value = "id", dataType = "Long", paramType = "query", required = true)
    @SystemControllerLog(description = "退款-根据id删除")
    public ResultData delete(Long id) {
        logger.debug("[" + getIpAddr() + "] WxRefundOrderController::delete");
        wxRefundOrderService.deleteById(id);
        return new ResultData(Result.SUCCESS, "删除成功", null);
    }

    @ApiOperation("根据id查询接口")
    @GetMapping("/findById")
    @ApiImplicitParam(name = "id", value = "id", dataType = "Long", paramType = "query", required = true)
    @SystemControllerLog(description = "退款-id查询")
    public ResultData findById(Long id) {
        logger.debug("[" + getIpAddr() + "] WxRefundOrderController::findById");
        return new ResultData(Result.SUCCESS, "查询成功", wxRefundOrderService.getById(id));
    }


}
